let characteristics = {
  "ws" : -10,
  "bs" : -10,
  "s" : 0,
  "t" : 15,
  "i" : 15,
  "ag" : -20,
  "dex" : 0,
  "int" : 20,
  "wp" : 10,
  "fel" : 10
}
let skills = ["Charme", "Focalisation", "Entertain (Prophecy)", "Intuition"]
let skillAdvancements = [0, 0, 20, 10]
let talents = ["Détection d’artefact", "Menaçant", "Sixième Sens"]
let traits = ["Condamné", "Spellcaster (Lore of Life)", "Protection"]
let trappings = []
let items = [];
let spells = ["Forêt d'épines"];

let updateObj = this.actor.toObject();

for (let ch in characteristics)
{
  updateObj.system.characteristics[ch].modifier += characteristics[ch];
}

for (let index = 0; index < skills.length; index++)
{
  let Compétence = skills[index]
  let skillItem;
  skillItem = updateObj.items.find(i => i.name == Compétence && i.type == "Compétence")
  if (skillItem)
      skillItem.system.advances.value += skillAdvancements[index]
  else 
  {
      skillItem = await game.wfrp4e.utility.findSkill(Compétence)
      skillItem = skillItem.toObject();
      skillItem.system.advances.value = skillAdvancements[index];
      items.push(skillItem);
  }
}

for (let talent of talents)
{
  let talentItem = await game.wfrp4e.utility.findTalent(talent)
  if (talentItem)
  {
      items.push(talentItem.toObject());
  }
  else 
  {
      ui.notifications.warn(`Could not find ${talent}`, {permanent : true})
  }
}

const traitRegex = /(?:,?(.+?)(\+?\d{1,2}\+?)?\s*?(?:\((.+?)\)\s*(\+?\d{1,2})?|,|$))/gm
for (let trait of traits)
{
  let traitMatches = trait.matchAll(traitRegex).next().value
  let traitName = traitMatches[1]
  let traitVal = traitMatches[2] || traitMatches[4] // could be match 2 or 4 depending on if there'}`).trim()
  }
  else
      traitItem.system.specification.value = traitSpec

  items.push(traitItem)

}

for (let trapping of trappings)
{
  let trappingItem = await game.wfrp4e.utility.findItem(trapping)
  if (trappingItem)
  {
      trappingItem = trappingItem.toObject()

      trappingItem.system.equipped.value = true;

      items.push(trappingItem);
  }
  else
  {
      ui.notifications.warn(`Could not find ${trapping}`, {permanent : true})
  }
}

for (let spell of spells)
{
  let spellItem = await game.wfrp4e.utility.findItem(spell)
  if (spellItem)
  {
      spellItem = spellItem.toObject()

      items.push(spellItem);
  }
  else
  {
      ui.notifications.warn(`Could not find ${spell}`, {permanent : true})
  }
}

updateObj.name = updateObj.name +='Arme','Cornes','Tail','Tentacules','Morsure') ? traitVal - parseInt(characteristicValues[3]/10) : traitVal;
      traitItem.name = (traitItem.name +  ` ${traitSpec ? "("+ traitSpec + ")" : ""}`).trim()
  }
  else
      traitItem.system.specification.value = traitSpec

  items.push(traitItem)

}

for (let trapping of trappings)
{
  let trappingItem = await game.wfrp4e.utility.findItem(trapping)
  if (trappingItem)
  {
      trappingItem = trappingItem.toObject()

      trappingItem.system.equipped.value = true;

      items.push(trappingItem);
  }
  else
  {
      ui.notifications.warn(`Could not find ${trapping}`, {permanent : true})
  }
}

for (let spell of spells)
{
  let spellItem = await game.wfrp4e.utility.findItem(spell)
  if (spellItem)
  {
      spellItem = spellItem.toObject()

      items.push(spellItem);
  }
  else
  {
      ui.notifications.warn(`Could not find ${spell}`, {permanent : true})
  }
}

updateObj.name = updateObj.name += " " + this.effect.name

await this.actor.update(updateObj)
this.actor.createEmbeddedDocuments("Item", items);